#include "alloc.h"
#include "debug.h"
#include "drivers.h"
#include "gdt.h"
#include "icon.h"
#include "idt.h"
#include "kprintf.h"
#include "memory.h"
#include "multiboot.h"
#include "power.h"
#include "shell.h"
#include "string.h"
#include "task.h"
#include "terminal.h"
#include "time.h"
#include "vbe.h"

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error                                                                         \
    "You are not using a cross-compiler, you will most certainly run into trouble"
#endif

/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

static void bozo(int int_code)
{
	kprintf("apagnan code\n");
}

void kernel_main(multiboot_info_t *mbd, uint32_t magic)
{
	terminal_initialize();
	init_gdt();
	init_idt();
	init_memory(mbd, magic);
	load_drivers();
	create_kernel_task();
	PRINT_UINT(vsize(vmalloc(1231231)));
	for (uint8_t i = 0; i < 10; i++)
		vmalloc(32);
	/*
	 uint32_t count = 0;
	 while (vmalloc(10))
		count++;
	kprintf("%d allocations done\n", count);
	*/
	// kpanic("uwu");
	shell_init();
}
